;=====================================================
;VARIOUS PROCEDURES
;=====================================================

;============================================================
DisableInGameKeys:
;============================================================
push eax
push edx
push esi
     mov edx,[KEY_LIST_ADDR]
     lea esi,[edx+15*8]
     add edx,4
     xor eax,eax

     DisableInGameKeys_Loop:
     mov [edx],eax
     add edx,8
     cmp edx,esi
     jb DisableInGameKeys_Loop

pop esi
pop edx
pop eax
ret

;============================================================
EnableInGameKeys:
;============================================================
push eax
push edx
push esi
     mov edx,[KEY_LIST_ADDR]
     mov esi,DefaultKeyBOOLS
     add edx,4

     EnableInGameKeys_Loop:
     mov eax,[esi]
     mov [edx],eax
     add edx,8
     add esi,4
     cmp esi,DefaultKeyBOOLS_END
     jb EnableInGameKeys_Loop

pop esi
pop edx
pop eax
ret


;============================================================
RANDOMIZE_RANDOM_PROC:
;============================================================
invoke time,0
invoke srand,eax
add esp,8
ret

;============================================================
GetRandomNumber:	;[esp+4] = below or equal to this number and not zero
;============================================================
invoke rand
mov ecx,[esp+4]
test ecx,ecx
     jz GetRandom_DivideByZero
xor edx,edx		;parameter must NOT be null
div ecx 		;(note: I didn't think of this)
mov eax,edx		;remainder
add eax,1
ret 4			;returns number in eax (0 if param was null)

GetRandom_DivideByZero:
xor eax,eax
ret 4

;============================================================
IsLevelSavedGame:	;returns 0 if false
;============================================================
push edi
push ecx
push esi

or ecx,0FFFFFFFFh
mov edi,[LEVELNAME_OBJ]
add edi,20
xor al,al
    repnz scasb

xor eax,eax
cmp DWORD [edi-5],'.SCN'
    jz LevelNotSavedGame_34345555
cmp DWORD [edi-5],'.scn'
    jz LevelNotSavedGame_34345555
or al,1
LevelNotSavedGame_34345555:

pop esi
pop ecx
pop edi
ret

;============================================================
	GetPrivateProfileFloat	dd	GetINIFloat
;============================================================
GetINIFloat:	;returns 32-bit float in eax (null if doesn't exist or if 0)
;============================================================
;[esp+4]=points to section name
;[esp+8]=points to key name
;[esp+12]=default string if none found
;[esp+16]=points to INI filename
push ebp
mov ebp,esp
sub esp,104

	lea edx,[ebp-100]
invoke GetPrivateProfileString,[ebp+8],[ebp+12],[ebp+16],edx,\
		100,[ebp+20]

	lea edx,[ebp-104]
	lea eax,[ebp-100]

	cmp BYTE [eax],';'
	    jnz NoEmptyFloatEntry2
	    mov eax,[ebp+16]
	    jmp NoEmptyFloatEntry
	NoEmptyFloatEntry2:

	cmp BYTE [eax],0
	    jnz NoEmptyFloatEntry
	    mov eax,[ebp+16]
	NoEmptyFloatEntry:

invoke sscanf,eax,_float,edx
	add esp,12

mov eax,[esp]
mov esp,ebp
pop ebp
ret 16
